<?php
namespace Folha\Repositories;

use \Folha\Entities\VabIntegtransph as Integtransph;
class VabIntegtransph extends \Doctrine\ORM\EntityRepository
{

    public static function inserirNovo(Integtransph $registro)
    {
        try {
            $params = array(
                'P_CDFORMATOINTEG'     => $registro->getCdformatointeg(),
                'P_CDINTEGTRANSP'      => $registro->getCdintegtransp(),
                'P_CDOPERINCLUSAO'     => $registro->getCdoperinclusao(),
                'P_CDOPERULTATU'       => $registro->getCdoperultatu(),
                'P_DTINCLUSAO'         => $registro->getDtinclusao()->format('d/m/Y'),
                'P_DTMESCOMPINTEG'     => $registro->getDtmescompinteg()->format('d/m/Y'),
                'P_DTULTATU'           => $registro->getDtultatu()->format('d/m/Y'),
                'P_DTULTUTILIZACAO'    => ($registro->getDtultutilizacao())?$registro->getDtultutilizacao()->format('d/m/Y'):null,
                'P_IDATIVO'            => $registro->getIdativo(),
                'P_IDINTEGRESERVA'     => $registro->getIdintegreserva(),
                'P_NRINTEGTRANSPH'     => $registro->getNrintegtransph(),
                'P_NRINTEGTRANSPM'     => $registro->getNrintegtranspm(),
                'P_NRORG'              => $registro->getNrorg(),
                'P_NRORGINCLUSAO'      => $registro->getNrorginclusao(),
                'P_NRORGULTATU'        => $registro->getNrorgultatu(),
                'P_NRTIPOINTEGTRANSP'  => $registro->getNrtipointegtransp(),
                'P_NRTIPOLINHAVINC'    => $registro->getNrtipolinhavinc(),
                'P_VRMULTIPLOINTEG'    => $registro->getVrmultiplointeg(),
                'P_VRSALDOULTCONSULTA' => $registro->getVrsaldoultconsulta(),
                'P_NRMATRICULA'        => $registro->getNrmatricula(),
                'P_NRESTRUTURAM'       => $registro->getNrestruturam()
            );
            $sql = <<<SQL
INSERT INTO VAB_INTEGTRANSPH(
    CDFORMATOINTEG,
    CDINTEGTRANSP,
    CDOPERINCLUSAO,
    CDOPERULTATU,
    DTINCLUSAO,
    DTMESCOMPINTEG,
    DTULTATU,
    DTULTUTILIZACAO,
    IDATIVO,
    IDINTEGRESERVA,
    NRINTEGTRANSPH,
    NRINTEGTRANSPM,
    NRORG,
    NRORGINCLUSAO,
    NRORGULTATU,
    NRTIPOINTEGTRANSP,
    NRTIPOLINHAVINC,
    VRMULTIPLOINTEG,
    VRSALDOULTCONSULTA,
    NRMATRICULA,
    NRESTRUTURAM
)
VALUES (
    :P_CDFORMATOINTEG,
    :P_CDINTEGTRANSP,
    :P_CDOPERINCLUSAO,
    :P_CDOPERULTATU,
    :P_DTINCLUSAO,
    :P_DTMESCOMPINTEG,
    :P_DTULTATU,
    :P_DTULTUTILIZACAO,
    :P_IDATIVO,
    :P_IDINTEGRESERVA,
    :P_NRINTEGTRANSPH,
    :P_NRINTEGTRANSPM,
    :P_NRORG,
    :P_NRORGINCLUSAO,
    :P_NRORGULTATU,
    :P_NRTIPOINTEGTRANSP,
    :P_NRTIPOLINHAVINC,
    :P_VRMULTIPLOINTEG,
    :P_VRSALDOULTCONSULTA,
    :P_NRMATRICULA,
    :P_NRESTRUTURAM
)
SQL;
            \Setforms2\Shared\Registry::getEntityManager()->getConnection()->executeUpdate($sql, $params);

            return true;

        } catch (\Exception $e) {
            throw $e;
        }

    }

    public static function atualizarRegistro(Integtransph $registro)
    {
        try {
            $params = array(
                'P_CDFORMATOINTEG'     => $registro->getCdformatointeg(),
                'P_CDINTEGTRANSP'      => $registro->getCdintegtransp(),
                'P_CDOPERINCLUSAO'     => $registro->getCdoperinclusao(),
                'P_CDOPERULTATU'       => $registro->getCdoperultatu(),
                'P_DTINCLUSAO'         => $registro->getDtinclusao()->format('d/m/y'),
                'P_DTMESCOMPINTEG'     => $registro->getDtmescompinteg()->format('d/m/y'),
                'P_DTULTATU'           => $registro->getDtultatu()->format('d/m/y'),
                'P_DTULTUTILIZACAO'    => ($registro->getDtultutilizacao())?$registro->getDtultutilizacao()->format('d/m/y'):null,
                'P_IDATIVO'            => $registro->getIdativo(),
                'P_IDINTEGRESERVA'     => $registro->getIdintegreserva(),
                'P_NRINTEGTRANSPH'     => $registro->getNrintegtransph(),
                'P_NRINTEGTRANSPM'     => $registro->getNrintegtranspm(),
                'P_NRORG'              => $registro->getNrorg(),
                'P_NRORGINCLUSAO'      => $registro->getNrorginclusao(),
                'P_NRORGULTATU'        => $registro->getNrorgultatu(),
                'P_NRTIPOINTEGTRANSP'  => $registro->getNrtipointegtransp(),
                'P_NRTIPOLINHAVINC'    => $registro->getNrtipolinhavinc(),
                'P_VRMULTIPLOINTEG'    => $registro->getVrmultiplointeg(),
                'P_VRSALDOULTCONSULTA' => $registro->getVrsaldoultconsulta(),
                'P_NRMATRICULA'        => $registro->getNrmatricula(),
                'P_NRESTRUTURAM'       => $registro->getNrestruturam()
            );
            $sql = <<<SQL
UPDATE VAB_INTEGTRANSPH
SET
    CDOPERULTATU = :P_CDOPERULTATU,
    DTULTATU = :P_DTULTATU,
    NRORGULTATU = :P_NRORGULTATU,
    VRSALDOULTCONSULTA = :P_VRSALDOULTCONSULTA,
    CDFORMATOINTEG = :P_CDFORMATOINTEG,
    NRMATRICULA = :P_NRMATRICULA,
    NRESTRUTURAM = :P_NRESTRUTURAM

WHERE NRINTEGTRANSPH = :P_NRINTEGTRANSPH
    AND NRINTEGTRANSPM = :P_NRINTEGTRANSPM
    AND NRORG = :P_NRORG
SQL;
            \Setforms2\Shared\Registry::getEntityManager()->getConnection()->executeUpdate($sql, $params);

            return true;

        } catch (\Exception $e) {
            throw $e;
        }
    }

}