/* Tabela VENDEDOR*/
/* Descrio: A trigger insere registros na tabela LOGOPERA a partir de alteraes na tabela VENDEDOR*/
/* Objetivo: Gerar um log que vai registrar as alteraes na tabela VENDEDOR, utilizando a tabela Geral de Logs de Operaes */

IF EXISTS(SELECT *
          FROM SYSOBJECTS O, SYSUSERS U
          WHERE O.NAME = 'LOG_EXP_VENDEDOR' AND
                TYPE   = 'TR'              AND
                U.UID  = O.UID             AND
                U.NAME = USER)

DROP TRIGGER LOG_EXP_VENDEDOR
GO
CREATE TRIGGER LOG_EXP_VENDEDOR
ON VENDEDOR
FOR UPDATE,INSERT, DELETE
AS
BEGIN
  DECLARE @V_USUARIO             VARCHAR(40);
  DECLARE @V_TIPO                VARCHAR(1);
  DECLARE @V_TPMOVI              VARCHAR(1);
  DECLARE @V_ITPESQ              VARCHAR(40);
  DECLARE @V_DESC                VARCHAR(500);
  DECLARE @V_CDFILLOGOPER        VARCHAR(4);
  DECLARE @V_DSREMOTEADDR        VARCHAR(15);
  DECLARE @V_DSREMOTEHOST        VARCHAR(15);
  DECLARE @V_DSSERVERRDM         VARCHAR(20);
  DECLARE @V_DSSERVMETHOD        VARCHAR(30);
  DECLARE @V_DSREMOTEOPER        VARCHAR(12);
  DECLARE @V_DTOPER              DATETIME;

  DECLARE @V_CDVENDEDOR_NEW      VARCHAR(4);
  DECLARE @V_IDTPIJURVEN_NEW     VARCHAR(1);
  DECLARE @V_NRINSJURVEN_NEW     VARCHAR(20);
  DECLARE @V_NMRAZSOCVEN_NEW     VARCHAR(50);
  DECLARE @V_NMFANVEN_NEW        VARCHAR(50);
  DECLARE @V_DTNASCVEN_NEW       DATETIME;
  DECLARE @V_VRPECOMVEN_NEW      DOUBLE PRECISION;
  DECLARE @V_VRPEMAXDESVE_NEW    DOUBLE PRECISION;
  DECLARE @V_CDOPERADOR_NEW      VARCHAR(12);
  DECLARE @V_CDFORNECED_NEW      VARCHAR(21);
  DECLARE @V_CDCOMISSAO_NEW      VARCHAR(10);
  DECLARE @V_IDLIGEXTVEND_NEW    VARCHAR(1);
  DECLARE @V_CDPRECOBASE_NEW     VARCHAR(2);
  DECLARE @V_CDSETOR_NEW         VARCHAR(4);
  DECLARE @V_DTULTATUVEND_NEW    DATETIME;
  DECLARE @V_CDFILIAL_NEW        VARCHAR(4);
  DECLARE @V_CDCAIXA_NEW         VARCHAR(3);
  DECLARE @V_SGVENDORCEVE_NEW    VARCHAR(5);
  DECLARE @V_VRAPROVAUTOORC_NEW  DOUBLE PRECISION;
  DECLARE @V_CDMARKUP_NEW        VARCHAR(3);
  DECLARE @V_DSPLACAVEICULO_NEW  VARCHAR(10);
  DECLARE @V_VRCOMPROVEND_NEW    DOUBLE PRECISION;
  DECLARE @V_CDCOMISSAOPROMO_NEW VARCHAR(10);
  DECLARE @V_IDGERACOMISVEND_NEW VARCHAR(1);
  DECLARE @V_IDCARGOVEND_NEW     VARCHAR(1);
  DECLARE @V_CDVENDEDORSUP_NEW   VARCHAR(4);
  DECLARE @V_NRPARCNEGOCIO_NEW   NUMERIC;
  DECLARE @V_CDVENDEDORGER_NEW   VARCHAR(4);
  DECLARE @V_CDVENDEDORAUX_NEW   VARCHAR(4);

  DECLARE @V_CDVENDEDOR_OLD      VARCHAR(4);
  DECLARE @V_IDTPIJURVEN_OLD     VARCHAR(1);
  DECLARE @V_NRINSJURVEN_OLD     VARCHAR(20);
  DECLARE @V_NMRAZSOCVEN_OLD     VARCHAR(50);
  DECLARE @V_NMFANVEN_OLD        VARCHAR(50);
  DECLARE @V_DTNASCVEN_OLD       DATETIME;
  DECLARE @V_VRPECOMVEN_OLD      DOUBLE PRECISION;
  DECLARE @V_VRPEMAXDESVE_OLD    DOUBLE PRECISION;
  DECLARE @V_CDOPERADOR_OLD      VARCHAR(12);
  DECLARE @V_CDFORNECED_OLD      VARCHAR(21);
  DECLARE @V_CDCOMISSAO_OLD      VARCHAR(10);
  DECLARE @V_IDLIGEXTVEND_OLD    VARCHAR(1);
  DECLARE @V_CDPRECOBASE_OLD     VARCHAR(2);
  DECLARE @V_CDSETOR_OLD         VARCHAR(4);
  DECLARE @V_DTULTATUVEND_OLD    DATETIME;
  DECLARE @V_CDFILIAL_OLD        VARCHAR(4);
  DECLARE @V_CDCAIXA_OLD         VARCHAR(3);
  DECLARE @V_SGVENDORCEVE_OLD    VARCHAR(5);
  DECLARE @V_VRAPROVAUTOORC_OLD  DOUBLE PRECISION;
  DECLARE @V_CDMARKUP_OLD        VARCHAR(3);
  DECLARE @V_DSPLACAVEICULO_OLD  VARCHAR(10);
  DECLARE @V_VRCOMPROVEND_OLD    DOUBLE PRECISION;
  DECLARE @V_CDCOMISSAOPROMO_OLD VARCHAR(10);
  DECLARE @V_IDGERACOMISVEND_OLD VARCHAR(1);
  DECLARE @V_IDCARGOVEND_OLD     VARCHAR(1);
  DECLARE @V_CDVENDEDORSUP_OLD   VARCHAR(4);
  DECLARE @V_NRPARCNEGOCIO_OLD   NUMERIC;
  DECLARE @V_CDVENDEDORGER_OLD   VARCHAR(4);
  DECLARE @V_CDVENDEDORAUX_OLD   VARCHAR(4);

   SET @V_TIPO = '0';
   SET @V_DESC = '';
   SET @V_CDFILLOGOPER = '';
   SET @V_USUARIO = '-';

   DECLARE C_CURSOR_R CURSOR FOR
      SELECT
         'D' IDCOMANDO,
         NULL, NULL, NULL, NULL, NULL,
         NULL, NULL, NULL, NULL, NULL,
         NULL, NULL, NULL, NULL, NULL,
         NULL, NULL, NULL, NULL, NULL,
         NULL, NULL, NULL, NULL, NULL,
         NULL, NULL, NULL, NULL,
         CDVENDEDOR,
         IDTPIJURVEN,
         NRINSJURVEN,
         NMRAZSOCVEN,
         NMFANVEN,
         DTNASCVEN,
         VRPECOMVEN,
         VRPEMAXDESVE,
         CDOPERADOR,
         CDFORNECED,
         CDCOMISSAO,
         IDLIGEXTVEND,
         CDPRECOBASE,
         CDSETOR,
         DTULTATUVEND,
         CDFILIAL,
         CDCAIXA,
         SGVENDORCEVE,
         VRAPROVAUTOORC,
         CDMARKUP,
         DSPLACAVEICULO,
         VRCOMPROVEND,
         CDCOMISSAOPROMO,
         IDGERACOMISVEND,
         IDCARGOVEND,
         CDVENDEDORSUP,
         NRPARCNEGOCIO,
         CDVENDEDORGER,
         CDVENDEDORAUX
      FROM
         DELETED
      WHERE
         0 = (SELECT COUNT(*) FROM INSERTED)

      UNION ALL

      SELECT
         'U' IDCOMANDO,
         INSERTED.CDVENDEDOR,
         INSERTED.IDTPIJURVEN,
         INSERTED.NRINSJURVEN,
         INSERTED.NMRAZSOCVEN,
         INSERTED.NMFANVEN,
         INSERTED.DTNASCVEN,
         INSERTED.VRPECOMVEN,
         INSERTED.VRPEMAXDESVE,
         INSERTED.CDOPERADOR,
         INSERTED.CDFORNECED,
         INSERTED.CDCOMISSAO,
         INSERTED.IDLIGEXTVEND,
         INSERTED.CDPRECOBASE,
         INSERTED.CDSETOR,
         INSERTED.DTULTATUVEND,
         INSERTED.CDFILIAL,
         INSERTED.CDCAIXA,
         INSERTED.SGVENDORCEVE,
         INSERTED.VRAPROVAUTOORC,
         INSERTED.CDMARKUP,
         INSERTED.DSPLACAVEICULO,
         INSERTED.VRCOMPROVEND,
         INSERTED.CDCOMISSAOPROMO,
         INSERTED.IDGERACOMISVEND,
         INSERTED.IDCARGOVEND,
         INSERTED.CDVENDEDORSUP,
         INSERTED.NRPARCNEGOCIO,
         INSERTED.CDVENDEDORGER,
         INSERTED.CDVENDEDORAUX,

         DELETED.CDVENDEDOR,
         DELETED.IDTPIJURVEN,
         DELETED.NRINSJURVEN,
         DELETED.NMRAZSOCVEN,
         DELETED.NMFANVEN,
         DELETED.DTNASCVEN,
         DELETED.VRPECOMVEN,
         DELETED.VRPEMAXDESVE,
         DELETED.CDOPERADOR,
         DELETED.CDFORNECED,
         DELETED.CDCOMISSAO,
         DELETED.IDLIGEXTVEND,
         DELETED.CDPRECOBASE,
         DELETED.CDSETOR,
         DELETED.DTULTATUVEND,
         DELETED.CDFILIAL,
         DELETED.CDCAIXA,
         DELETED.SGVENDORCEVE,
         DELETED.VRAPROVAUTOORC,
         DELETED.CDMARKUP,
         DELETED.DSPLACAVEICULO,
         DELETED.VRCOMPROVEND,
         DELETED.CDCOMISSAOPROMO,
         DELETED.IDGERACOMISVEND,
         DELETED.IDCARGOVEND,
         DELETED.CDVENDEDORSUP,
         DELETED.NRPARCNEGOCIO,
         DELETED.CDVENDEDORGER,
         DELETED.CDVENDEDORAUX

      FROM
         INSERTED,
         DELETED
      WHERE
         INSERTED.CDVENDEDOR   = DELETED.CDVENDEDOR

      UNION ALL

      SELECT
         'I' IDCOMANDO,
         INSERTED.CDVENDEDOR,
         INSERTED.IDTPIJURVEN,
         INSERTED.NRINSJURVEN,
         INSERTED.NMRAZSOCVEN,
         INSERTED.NMFANVEN,
         INSERTED.DTNASCVEN,
         INSERTED.VRPECOMVEN,
         INSERTED.VRPEMAXDESVE,
         INSERTED.CDOPERADOR,
         INSERTED.CDFORNECED,
         INSERTED.CDCOMISSAO,
         INSERTED.IDLIGEXTVEND,
         INSERTED.CDPRECOBASE,
         INSERTED.CDSETOR,
         INSERTED.DTULTATUVEND,
         INSERTED.CDFILIAL,
         INSERTED.CDCAIXA,
         INSERTED.SGVENDORCEVE,
         INSERTED.VRAPROVAUTOORC,
         INSERTED.CDMARKUP,
         INSERTED.DSPLACAVEICULO,
         INSERTED.VRCOMPROVEND,
         INSERTED.CDCOMISSAOPROMO,
         INSERTED.IDGERACOMISVEND,
         INSERTED.IDCARGOVEND,
         INSERTED.CDVENDEDORSUP,
         INSERTED.NRPARCNEGOCIO,
         INSERTED.CDVENDEDORGER,
         INSERTED.CDVENDEDORAUX,

         NULL, NULL, NULL, NULL, NULL,
         NULL, NULL, NULL, NULL, NULL,
         NULL, NULL, NULL, NULL, NULL,
         NULL, NULL, NULL, NULL, NULL,
         NULL, NULL, NULL, NULL, NULL,
         NULL, NULL, NULL, NULL
      FROM
         INSERTED
      WHERE
         0 = (SELECT COUNT(*) FROM DELETED)

   OPEN C_CURSOR_R;
   FETCH NEXT FROM C_CURSOR_R INTO @V_TIPO,
                                   @V_CDVENDEDOR_NEW, @V_IDTPIJURVEN_NEW, @V_NRINSJURVEN_NEW, @V_NMRAZSOCVEN_NEW, @V_NMFANVEN_NEW,
                                   @V_DTNASCVEN_NEW, @V_VRPECOMVEN_NEW, @V_VRPEMAXDESVE_NEW, @V_CDOPERADOR_NEW, @V_CDFORNECED_NEW,
                                   @V_CDCOMISSAO_NEW, @V_IDLIGEXTVEND_NEW, @V_CDPRECOBASE_NEW, @V_CDSETOR_NEW, @V_DTULTATUVEND_NEW,
                                   @V_CDFILIAL_NEW, @V_CDCAIXA_NEW, @V_SGVENDORCEVE_NEW, @V_VRAPROVAUTOORC_NEW, @V_CDMARKUP_NEW,
                                   @V_DSPLACAVEICULO_NEW, @V_VRCOMPROVEND_NEW, @V_CDCOMISSAOPROMO_NEW, @V_IDGERACOMISVEND_NEW,
                                   @V_IDCARGOVEND_NEW, @V_CDVENDEDORSUP_NEW, @V_NRPARCNEGOCIO_NEW, @V_CDVENDEDORGER_NEW,
                                   @V_CDVENDEDORAUX_NEW,
                                   
                                   @V_CDVENDEDOR_OLD, @V_IDTPIJURVEN_OLD, @V_NRINSJURVEN_OLD, @V_NMRAZSOCVEN_OLD, @V_NMFANVEN_OLD,
                                   @V_DTNASCVEN_OLD, @V_VRPECOMVEN_OLD, @V_VRPEMAXDESVE_OLD, @V_CDOPERADOR_OLD, @V_CDFORNECED_OLD,
                                   @V_CDCOMISSAO_OLD, @V_IDLIGEXTVEND_OLD, @V_CDPRECOBASE_OLD, @V_CDSETOR_OLD, @V_DTULTATUVEND_OLD,
                                   @V_CDFILIAL_OLD, @V_CDCAIXA_OLD, @V_SGVENDORCEVE_OLD, @V_VRAPROVAUTOORC_OLD, @V_CDMARKUP_OLD,
                                   @V_DSPLACAVEICULO_OLD, @V_VRCOMPROVEND_OLD, @V_CDCOMISSAOPROMO_OLD, @V_IDGERACOMISVEND_OLD,
                                   @V_IDCARGOVEND_OLD, @V_CDVENDEDORSUP_OLD, @V_NRPARCNEGOCIO_OLD, @V_CDVENDEDORGER_OLD,
                                   @V_CDVENDEDORAUX_OLD;

   WHILE (@@FETCH_STATUS = 0) BEGIN

      IF @V_TIPO = 'D' BEGIN

         IF @V_CDVENDEDOR_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'Vendedor = ' + ISNULL(@V_CDVENDEDOR_OLD,'') + ' ';
         END;
         IF @V_IDTPIJURVEN_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'Tipo de inscio jurdica = ' + ISNULL(@V_IDTPIJURVEN_OLD,'') + ' ';
         END;
         IF @V_NRINSJURVEN_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'Inscrio jurdica = ' + ISNULL(@V_NRINSJURVEN_OLD,'') + ' ';
         END;
         IF @V_NMRAZSOCVEN_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'Razo social = ' + ISNULL(@V_NMRAZSOCVEN_OLD,'') + ' ';
         END;
         IF @V_NMFANVEN_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'Nome fantasia = ' + ISNULL(@V_NMFANVEN_OLD,'') + ' ';
         END;
         IF @V_DTNASCVEN_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'Data de nascimento = ' + ISNULL(CONVERT(VARCHAR,@V_DTNASCVEN_OLD),'') + ' ';
         END;
         IF @V_VRPECOMVEN_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'Comisso = ' + ISNULL(CONVERT(VARCHAR,@V_VRPECOMVEN_OLD),'') + '% ';
         END;
         IF @V_VRPEMAXDESVE_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'Desconto mximo = ' + ISNULL(CONVERT(VARCHAR,@V_VRPEMAXDESVE_OLD),'') + '% ';
         END;
         IF @V_CDOPERADOR_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'Operador = ' + ISNULL(@V_CDOPERADOR_OLD,'') + ' ';
         END;
         IF @V_CDFORNECED_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'Fornecedor = ' + ISNULL(@V_CDFORNECED_OLD,'') + ' ';
         END;
         IF @V_CDCOMISSAO_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'Tabela de comisso = ' + ISNULL(@V_CDCOMISSAO_OLD,'') + ' ';
         END;
         IF @V_IDLIGEXTVEND_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'Realiza ligaes externas = ' + ISNULL(@V_IDLIGEXTVEND_OLD,'') + ' ';
         END;
         IF @V_CDPRECOBASE_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'Tabela de preo = ' + ISNULL(@V_CDPRECOBASE_OLD,'') + ' ';
         END;
         IF @V_CDSETOR_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'Setor = ' + ISNULL(@V_CDSETOR_OLD,'') + ' ';
         END;
         IF @V_DTULTATUVEND_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'ltima alterao = ' + ISNULL(CONVERT(VARCHAR,@V_DTULTATUVEND_OLD),'') + ' ';
         END;
         IF @V_CDFILIAL_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'Filial = ' + ISNULL(@V_CDFILIAL_OLD,'') + ' ';
         END;
         IF @V_CDCAIXA_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'Caixa = ' + ISNULL(@V_CDCAIXA_OLD,'') + ' ';
         END;
         IF @V_SGVENDORCEVE_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'Sigla = ' + ISNULL(@V_SGVENDORCEVE_OLD,'') + ' ';
         END;
         IF @V_VRAPROVAUTOORC_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'Aprovao automtica = ' + ISNULL(CONVERT(VARCHAR,@V_VRAPROVAUTOORC_OLD),'') + ' ';
         END;
         IF @V_CDMARKUP_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'Markup = ' + ISNULL(@V_CDMARKUP_OLD,'') + ' ';
         END;
         IF @V_DSPLACAVEICULO_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'Placa motoboy = ' + ISNULL(@V_DSPLACAVEICULO_OLD,'') + ' ';
         END;
         IF @V_VRCOMPROVEND_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'Comisso preo promocional = ' + ISNULL(CONVERT(VARCHAR,@V_VRCOMPROVEND_OLD),'') + '% ';
         END;
         IF @V_CDCOMISSAOPROMO_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'Tabela de comisso p/ promoo = ' + ISNULL(@V_CDCOMISSAOPROMO_OLD,'') + ' ';
         END;
         IF @V_IDGERACOMISVEND_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'Gera comisso = ' + ISNULL(@V_IDGERACOMISVEND_OLD,'') + ' ';
         END;
         IF @V_IDCARGOVEND_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'Cargo = ' + ISNULL(@V_IDCARGOVEND_OLD,'') + ' ';
         END;
         IF @V_CDVENDEDORSUP_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'Surpevisor = ' + ISNULL(@V_CDVENDEDORSUP_OLD,'') + ' ';
         END;
         IF @V_NRPARCNEGOCIO_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'Parceiro de negocio = ' + ISNULL(@V_NRPARCNEGOCIO_OLD,'') + ' ';
         END;
         IF @V_CDVENDEDORGER_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'Gerente = ' + ISNULL(@V_CDVENDEDORGER_OLD,'') + ' ';
         END;
         IF @V_CDVENDEDORAUX_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'Auxiliar = ' + ISNULL(@V_CDVENDEDORAUX_OLD,'') + ' ';
         END;        

         SET @V_TPMOVI = '3';
         SET @V_ITPESQ = @V_CDVENDEDOR_OLD;
      END
      ELSE BEGIN
         IF @V_TIPO = 'U' BEGIN
             IF (@V_CDVENDEDOR_OLD      <> @V_CDVENDEDOR_NEW     ) OR
                (@V_IDTPIJURVEN_OLD     <> @V_IDTPIJURVEN_NEW    ) OR
                (@V_NRINSJURVEN_OLD     <> @V_NRINSJURVEN_NEW    ) OR
                (@V_NMRAZSOCVEN_OLD     <> @V_NMRAZSOCVEN_NEW    ) OR
                (@V_NMFANVEN_OLD        <> @V_NMFANVEN_NEW       ) OR
                (@V_DTNASCVEN_OLD       <> @V_DTNASCVEN_NEW      ) OR
                (@V_VRPECOMVEN_OLD      <> @V_VRPECOMVEN_NEW     ) OR
                (@V_VRPEMAXDESVE_OLD    <> @V_VRPEMAXDESVE_NEW   ) OR
                (@V_CDOPERADOR_OLD      <> @V_CDOPERADOR_NEW     ) OR
                (@V_CDFORNECED_OLD      <> @V_CDFORNECED_NEW     ) OR
                (@V_CDCOMISSAO_OLD      <> @V_CDCOMISSAO_NEW     ) OR
                (@V_IDLIGEXTVEND_OLD    <> @V_IDLIGEXTVEND_NEW   ) OR
                (@V_CDPRECOBASE_OLD     <> @V_CDPRECOBASE_NEW    ) OR
                (@V_CDSETOR_OLD         <> @V_CDSETOR_NEW        ) OR
                (@V_DTULTATUVEND_OLD    <> @V_DTULTATUVEND_NEW   ) OR
                (@V_CDFILIAL_OLD        <> @V_CDFILIAL_NEW       ) OR
                (@V_CDCAIXA_OLD         <> @V_CDCAIXA_NEW        ) OR
                (@V_SGVENDORCEVE_OLD    <> @V_SGVENDORCEVE_NEW   ) OR
                (@V_VRAPROVAUTOORC_OLD  <> @V_VRAPROVAUTOORC_NEW ) OR
                (@V_CDMARKUP_OLD        <> @V_CDMARKUP_NEW       ) OR
                (@V_DSPLACAVEICULO_OLD  <> @V_DSPLACAVEICULO_NEW ) OR
                (@V_VRCOMPROVEND_OLD    <> @V_VRCOMPROVEND_NEW   ) OR
                (@V_CDCOMISSAOPROMO_OLD <> @V_CDCOMISSAOPROMO_NEW) OR
                (@V_IDGERACOMISVEND_OLD <> @V_IDGERACOMISVEND_NEW) OR
                (@V_IDCARGOVEND_OLD     <> @V_IDCARGOVEND_NEW    ) OR
                (@V_CDVENDEDORSUP_OLD   <> @V_CDVENDEDORSUP_NEW  ) OR
                (@V_NRPARCNEGOCIO_OLD   <> @V_NRPARCNEGOCIO_NEW  ) OR
                (@V_CDVENDEDORGER_OLD   <> @V_CDVENDEDORGER_NEW  ) OR
                (@V_CDVENDEDORAUX_OLD   <> @V_CDVENDEDORAUX_NEW  ) BEGIN

               SET @V_TPMOVI = '2';
               SET @V_ITPESQ = @V_CDVENDEDOR_OLD;
            END;
         END
         ELSE BEGIN
            SET @V_TPMOVI = '1';
            SET @V_ITPESQ = @V_CDVENDEDOR_NEW;
         END;

         IF ISNULL(@V_CDVENDEDOR_NEW, '!') <> ISNULL(@V_CDVENDEDOR_OLD, '!') BEGIN
            SET @V_DESC = @V_DESC + 'Vendedor = ' + @V_CDVENDEDOR_NEW;
         END;
         IF ISNULL(@V_IDTPIJURVEN_NEW, '!') <> ISNULL(@V_IDTPIJURVEN_OLD, '!') BEGIN
            SET @V_DESC = @V_DESC + 'Tipo de inscio jurdica = ' + @V_IDTPIJURVEN_NEW + ' ';
         END;
         IF ISNULL(@V_NRINSJURVEN_NEW, '!') <> ISNULL(@V_NRINSJURVEN_OLD, '!') BEGIN
            SET @V_DESC = @V_DESC + 'Inscrio jurdica = ' + @V_NRINSJURVEN_NEW + ' ';
         END;
         IF ISNULL(@V_NMRAZSOCVEN_NEW, '!') <> ISNULL(@V_NMRAZSOCVEN_OLD, '!') BEGIN
            SET @V_DESC = @V_DESC + 'Razo social = ' + @V_NMRAZSOCVEN_NEW + ' ';
         END;
         IF ISNULL(@V_NMFANVEN_NEW, '!') <> ISNULL(@V_NMFANVEN_OLD, '!') BEGIN
            SET @V_DESC = @V_DESC + 'Nome fantasia = ' + @V_NMFANVEN_NEW + ' ';
         END;
         IF ISNULL(CONVERT(VARCHAR,@V_DTNASCVEN_NEW), '!') <> ISNULL(CONVERT(VARCHAR,@V_DTNASCVEN_OLD), '!') BEGIN
            SET @V_DESC = @V_DESC + 'Data de nascimento = ' + @V_DTNASCVEN_NEW + ' ';
         END;
         IF ISNULL(CONVERT(VARCHAR,@V_VRPECOMVEN_NEW), '!') <> ISNULL(CONVERT(VARCHAR,@V_VRPECOMVEN_OLD), '!') BEGIN
            SET @V_DESC = @V_DESC + 'Comisso = ' + @V_VRPECOMVEN_NEW + '% ';
         END;
         IF ISNULL(CONVERT(VARCHAR,@V_VRPEMAXDESVE_NEW), '!') <> ISNULL(CONVERT(VARCHAR,@V_VRPEMAXDESVE_OLD), '!') BEGIN
            SET @V_DESC = @V_DESC + 'Desconto mximo = ' + @V_VRPEMAXDESVE_NEW + '% ';
         END;
         IF ISNULL(@V_CDOPERADOR_NEW, '!') <> ISNULL(@V_CDOPERADOR_OLD, '!') BEGIN
            SET @V_DESC = @V_DESC + 'Operador = ' + @V_CDOPERADOR_NEW + ' ';
         END;
         IF ISNULL(@V_CDFORNECED_NEW, '!') <> ISNULL(@V_CDFORNECED_OLD, '!') BEGIN
            SET @V_DESC = @V_DESC + 'Fornecedor = ' + @V_CDFORNECED_NEW + ' ';
         END;
         IF ISNULL(@V_CDCOMISSAO_NEW, '!') <> ISNULL(@V_CDCOMISSAO_OLD, '!') BEGIN
            SET @V_DESC = @V_DESC + 'Tabela de comisso = ' + @V_CDCOMISSAO_NEW + ' ';
         END;
         IF ISNULL(@V_IDLIGEXTVEND_NEW, '!') <> ISNULL(@V_IDLIGEXTVEND_OLD, '!') BEGIN
            SET @V_DESC = @V_DESC + 'Realiza ligaes externas = ' + @V_IDLIGEXTVEND_NEW + ' ';
         END;
         IF ISNULL(@V_CDPRECOBASE_NEW, '!') <> ISNULL(@V_CDPRECOBASE_OLD, '!') BEGIN
            SET @V_DESC = @V_DESC + 'Tabela de preo = ' + @V_CDPRECOBASE_NEW + ' ';
         END;
         IF ISNULL(@V_CDSETOR_NEW, '!') <> ISNULL(@V_CDSETOR_OLD, '!') BEGIN
            SET @V_DESC = @V_DESC + 'Setor = ' + @V_CDSETOR_NEW + ' ';
         END;
         IF ISNULL(CONVERT(VARCHAR,@V_DTULTATUVEND_NEW), '!') <> ISNULL(CONVERT(VARCHAR,@V_DTULTATUVEND_OLD), '!') BEGIN
            SET @V_DESC = @V_DESC + 'ltima alterao = ' + @V_DTULTATUVEND_NEW + ' ';
         END;
         IF ISNULL(@V_CDFILIAL_NEW, '!') <> ISNULL(@V_CDFILIAL_OLD, '!') BEGIN
            SET @V_DESC = @V_DESC + 'Filial = ' + @V_CDFILIAL_NEW + ' ';
         END;
         IF ISNULL(@V_CDCAIXA_NEW, '!') <> ISNULL(@V_CDCAIXA_OLD, '!') BEGIN
            SET @V_DESC = @V_DESC + 'Caixa = ' + @V_CDCAIXA_NEW + ' ';
         END;
         IF ISNULL(@V_SGVENDORCEVE_NEW, '!') <> ISNULL(@V_SGVENDORCEVE_OLD, '!') BEGIN
            SET @V_DESC = @V_DESC + 'Sigla = ' + @V_SGVENDORCEVE_NEW + ' ';
         END;
         IF ISNULL(CONVERT(VARCHAR,@V_VRAPROVAUTOORC_NEW), '!') <> ISNULL(CONVERT(VARCHAR,@V_VRAPROVAUTOORC_OLD), '!') BEGIN
            SET @V_DESC = @V_DESC + 'Aprovao automtica = ' + @V_VRAPROVAUTOORC_NEW + ' ';
         END;
         IF ISNULL(@V_CDMARKUP_NEW, '!') <> ISNULL(@V_CDMARKUP_OLD, '!') BEGIN
            SET @V_DESC = @V_DESC + 'Markup = ' + @V_CDMARKUP_NEW + ' ';
         END;
         IF ISNULL(@V_DSPLACAVEICULO_NEW, '!') <> ISNULL(@V_DSPLACAVEICULO_OLD, '!') BEGIN
            SET @V_DESC = @V_DESC + 'Placa motoboy = ' + @V_DSPLACAVEICULO_NEW + ' ';
         END;
         IF ISNULL(CONVERT(VARCHAR,@V_VRCOMPROVEND_NEW), '!') <> ISNULL(CONVERT(VARCHAR,@V_VRCOMPROVEND_OLD), '!') BEGIN
            SET @V_DESC = @V_DESC + 'Comisso preo promocional = ' + @V_VRCOMPROVEND_NEW + '% ';
         END;
         IF ISNULL(@V_CDCOMISSAOPROMO_NEW, '!') <> ISNULL(@V_CDCOMISSAOPROMO_OLD, '!') BEGIN
            SET @V_DESC = @V_DESC + 'Tabela de comisso p/ promoo = ' + @V_CDCOMISSAOPROMO_NEW + ' ';
         END;
         IF ISNULL(@V_IDGERACOMISVEND_NEW, '!') <> ISNULL(@V_IDGERACOMISVEND_OLD, '!') BEGIN
            SET @V_DESC = @V_DESC + 'Gera comisso = ' + @V_IDGERACOMISVEND_NEW + ' ';
         END;
         IF ISNULL(@V_IDCARGOVEND_NEW, '!') <> ISNULL(@V_IDCARGOVEND_OLD, '!') BEGIN
            SET @V_DESC = @V_DESC + 'Cargo = ' + @V_IDCARGOVEND_NEW + ' ';
         END;
         IF ISNULL(@V_CDVENDEDORSUP_NEW, '!') <> ISNULL(@V_CDVENDEDORSUP_OLD, '!') BEGIN
            SET @V_DESC = @V_DESC + 'Surpevisor = ' + @V_CDVENDEDORSUP_NEW + ' ';
         END;
         IF ISNULL(@V_NRPARCNEGOCIO_NEW, '!') <> ISNULL(@V_NRPARCNEGOCIO_OLD, '!') BEGIN
            SET @V_DESC = @V_DESC + 'Parceiro de negocio = ' + @V_NRPARCNEGOCIO_NEW + ' ';
         END;
         IF ISNULL(@V_CDVENDEDORGER_NEW, '!') <> ISNULL(@V_CDVENDEDORGER_OLD, '!') BEGIN
            SET @V_DESC = @V_DESC + 'Gerente = ' + @V_CDVENDEDORGER_NEW + ' ';
         END;
         IF ISNULL(@V_CDVENDEDORAUX_NEW, '!') <> ISNULL(@V_CDVENDEDORAUX_OLD, '!') BEGIN
            SET @V_DESC = @V_DESC + 'Auxiliar = ' + @V_CDVENDEDORAUX_NEW + ' ';
         END;        
      END;

      IF @V_TPMOVI <> '0' BEGIN
         EXEC NMUSUARIO  @V_USUARIO;
         EXEC WEBTUNNING @V_DSREMOTEADDR,
                         @V_DSREMOTEHOST,
                         @V_DSSERVERRDM,
                         @V_DSSERVMETHOD,
                         @V_DSREMOTEOPER;
         IF NOT @V_DESC IS NULL BEGIN

            SET @V_DTOPER = GETDATE();

            INSERT INTO LOGOPERA
               (NMTABELA,
                DTOPERACAO,
                NMRESPOPER,
                IDTIPOOPER,
                CDPESQITEM,
                DSOPERACAO,
                CDFILLOGOPER,
                DSRDMUSUOPER,
                DSENDUSUOPER,
                DSNMUSUOPER,
                DSMETUSUOPER,
                CDORESPOPER)
            VALUES
               ('VENDEDOR',
                @V_DTOPER,
                @V_USUARIO,
                @V_TPMOVI,
                @V_ITPESQ,
                SUBSTRING(@V_DESC,1,300),
                @V_CDFILLOGOPER,
                @V_DSSERVERRDM,
                @V_DSREMOTEADDR,
                @V_DSREMOTEHOST,
                @V_DSSERVMETHOD,
                @V_DSREMOTEOPER);

         END;
      END;
      FETCH NEXT FROM C_CURSOR_R INTO @V_TIPO,
                                      @V_CDVENDEDOR_NEW, @V_IDTPIJURVEN_NEW, @V_NRINSJURVEN_NEW, @V_NMRAZSOCVEN_NEW, @V_NMFANVEN_NEW,
                                      @V_DTNASCVEN_NEW, @V_VRPECOMVEN_NEW, @V_VRPEMAXDESVE_NEW, @V_CDOPERADOR_NEW, @V_CDFORNECED_NEW,
                                      @V_CDCOMISSAO_NEW, @V_IDLIGEXTVEND_NEW, @V_CDPRECOBASE_NEW, @V_CDSETOR_NEW, @V_DTULTATUVEND_NEW,
                                      @V_CDFILIAL_NEW, @V_CDCAIXA_NEW, @V_SGVENDORCEVE_NEW, @V_VRAPROVAUTOORC_NEW, @V_CDMARKUP_NEW,
                                      @V_DSPLACAVEICULO_NEW, @V_VRCOMPROVEND_NEW, @V_CDCOMISSAOPROMO_NEW, @V_IDGERACOMISVEND_NEW,
                                      @V_IDCARGOVEND_NEW, @V_CDVENDEDORSUP_NEW, @V_NRPARCNEGOCIO_NEW, @V_CDVENDEDORGER_NEW,
                                      @V_CDVENDEDORAUX_NEW,
                                   
                                      @V_CDVENDEDOR_OLD, @V_IDTPIJURVEN_OLD, @V_NRINSJURVEN_OLD, @V_NMRAZSOCVEN_OLD, @V_NMFANVEN_OLD,
                                      @V_DTNASCVEN_OLD, @V_VRPECOMVEN_OLD, @V_VRPEMAXDESVE_OLD, @V_CDOPERADOR_OLD, @V_CDFORNECED_OLD,
                                      @V_CDCOMISSAO_OLD, @V_IDLIGEXTVEND_OLD, @V_CDPRECOBASE_OLD, @V_CDSETOR_OLD, @V_DTULTATUVEND_OLD,
                                      @V_CDFILIAL_OLD, @V_CDCAIXA_OLD, @V_SGVENDORCEVE_OLD, @V_VRAPROVAUTOORC_OLD, @V_CDMARKUP_OLD,
                                      @V_DSPLACAVEICULO_OLD, @V_VRCOMPROVEND_OLD, @V_CDCOMISSAOPROMO_OLD, @V_IDGERACOMISVEND_OLD,
                                      @V_IDCARGOVEND_OLD, @V_CDVENDEDORSUP_OLD, @V_NRPARCNEGOCIO_OLD, @V_CDVENDEDORGER_OLD,
                                      @V_CDVENDEDORAUX_OLD;
   END;
   CLOSE C_CURSOR_R;
   DEALLOCATE C_CURSOR_R;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'LOG_EXP_VENDEDOR','5.85.XXX';
GO